# Weg 2: Objektorientierung mit Tabellen

from math import *

# Eine Klasse Punkt wird ber ihren Konstruktor mkPunkt definiert:

def mkPunkt(name,x,y):    
    punkt={"x":x, "y":y, "name":name, "Klasse":"Punkt"}
    def setzeName(ich,neu):
        ich["name"]=neu
    def betrag(ich): return sqrt(ich["x"]**2+ich["y"]**2)
    def nachRechts(ich,dx):
        ich["x"]=ich["x"]+dx
    def beschreibe(mich):
        return mich["Klasse"]+":"+mich["name"]+", x="+str(mich["x"])+", y="+str(mich["y"])
    methoden={"setzeName":setzeName, "betrag":betrag, "nachRechts":nachRechts,
              "beschreibe":beschreibe}
    punkt["methoden"]=methoden
    return punkt

def call(obj,methodenname,*args):
    alleArgs=[obj]+list(args)               # Das ist Liste [obj,arg1,arg2,..]
    methodenTabelle=obj["methoden"]         # Das ist die Methoden-Tabelle
    methode=methodenTabelle[methodenname]   # Das ist die Methoden-Funktion
    return apply(methode, alleArgs)

p1=mkPunkt("P1",5,6)
p2=mkPunkt("P2",5,9)
print call(p1,"beschreibe")
print call(p2,"beschreibe")
call(p1,"nachRechts",50)
print call(p1,"beschreibe")
call(p1,"setzeName","P1neu")
print call(p1,"beschreibe")
print call(p2,"beschreibe")


# Jetzt wird eine Klasse abgeleitet

def mkMittelPunkt(name,P,Q): # P Q sind Punkte
    punkt=mkPunkt(name,0,0) # Erst mal mit falschen Koordinaten erzeugen - Von Punkt erben
    punkt["Klasse"]="MittelPunkt"
    punkt["P"]=P            # Neue Attribute
    punkt["Q"]=Q
    def berechne(mich):     # Neue Methoden 
        mich["x"]=(P["x"]+Q["x"])/2.0
        mich["y"]=(P["y"]+Q["y"])/2.0
    berechne(punkt)
    punkt["methoden"]["berechne"]=berechne # ueberschreibt die in der Oberklasse
    return punkt


M=mkMittelPunkt("M1",p1,p2)
print
print call(M,"beschreibe")
call(p1,"nachRechts",50)
call(p2,"nachRechts",50)
print call(p1,"beschreibe")
print call(p2,"beschreibe")
call(M,"berechne")
print call(M,"beschreibe")
        

